Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/int.modified_WCOPY/user_contributed/readme
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/int.modified_WCOPY/user_contributed/readme	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/int.modified_WCOPY/user_contributed/readme	(revision 2696)
@@ -0,0 +1,3 @@
+Integrators in this directory have been contributed by KPP users. By
+default, KPP will not search for integrators in this directory. To
+activate them, move them into the int/ directory.
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/int.modified_WCOPY/user_contributed/ros2_manual.def
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/int.modified_WCOPY/user_contributed/ros2_manual.def	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/int.modified_WCOPY/user_contributed/ros2_manual.def	(revision 2696)
@@ -0,0 +1,5 @@
+#FUNCTION AGGREGATE
+#JACOBIAN SPARSE_LU_ROW 
+
+#DOUBLE ON
+#INTFILE ros2_manual
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/int.modified_WCOPY/user_contributed/ros2_manual.f90
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/int.modified_WCOPY/user_contributed/ros2_manual.f90	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/int.modified_WCOPY/user_contributed/ros2_manual.f90	(revision 2696)
@@ -0,0 +1,119 @@
+! Rosenbrock integrator with manual time step control
+! Solve: d/dt c = f(t,c)
+
+! written by Edwin Spee, CWI, Amsterdam. Last update: July 28, 1997
+! email: Edwin.Spee@cwi.nl (http://edwin-spee.mypage.org/)
+! adapted to KPP-2.1 by Rolf Sander, Max-Planck Institute, Mainz, Germany, 2005
+!
+! Integration method for Ros2:
+! C_{n+1} = C_n + 3/2 dt k_1 + 1/2 dt k_2
+! k_1 = S f(t_n, C_n)
+! k_2 = S [f(t_{n+1},C_n + dt k_1) - 2 k_1]
+!
+! where g = 1.0 + sqrt(0.5_dp),
+! S = (I - g dt J ) ^ {-1}
+! with J the Jacobian
+
+MODULE KPP_ROOT_Integrator
+
+  USE KPP_ROOT_Precision, ONLY: dp
+
+  IMPLICIT NONE
+  PUBLIC
+  SAVE
+
+  ! description of the error numbers IERR
+  CHARACTER(LEN=50), PARAMETER, DIMENSION(1) :: IERR_NAMES = (/ &
+    'dummy value                                       ' /)
+
+CONTAINS
+
+  ! **************************************************************************
+
+  SUBROUTINE INTEGRATE( TIN, TOUT, &
+    ICNTRL_U, RCNTRL_U, ISTATUS_U, RSTATUS_U, IERR_U )
+
+    IMPLICIT NONE
+
+    KPP_REAL, INTENT(IN) :: TIN  ! TIN - Start Time
+    KPP_REAL, INTENT(IN) :: TOUT ! TOUT - End Time
+    ! Optional input parameters and statistics
+    INTEGER,  INTENT(IN),  OPTIONAL :: ICNTRL_U(20)
+    KPP_REAL, INTENT(IN),  OPTIONAL :: RCNTRL_U(20)
+    INTEGER,  INTENT(OUT), OPTIONAL :: ISTATUS_U(20)
+    KPP_REAL, INTENT(OUT), OPTIONAL :: RSTATUS_U(20)
+    INTEGER,  INTENT(OUT), OPTIONAL :: IERR_U
+
+    CALL ROS2(TIN, TOUT)
+
+    ! if optional parameters are given for output
+    ! use them to store information in them
+    IF (PRESENT(ISTATUS_U)) ISTATUS_U(:) = 0
+    IF (PRESENT(RSTATUS_U)) THEN
+      RSTATUS_U(:) = 0._dp
+      RSTATUS_U(1)=TOUT ! put final time into RSTATUS_U
+    ENDIF
+    IF (PRESENT(IERR_U)) IERR_U = 1 ! dummy value
+
+  END SUBROUTINE INTEGRATE
+
+  ! **************************************************************************
+
+  SUBROUTINE ROS2(Tstart,Tend)
+
+    USE KPP_ROOT_Jacobian,         ONLY: Jac_SP
+    USE KPP_ROOT_Global,           ONLY: VAR,   & ! VARiable species
+                                         FIX,   & ! FIXed species
+                                         RCONST   ! rate coefficients
+    USE KPP_ROOT_JacobianSP,       ONLY: LU_DIAG
+    USE KPP_ROOT_Function,         ONLY: Fun
+    USE KPP_ROOT_LinearAlgebra,    ONLY: KppDecomp, KppSolve
+    USE KPP_ROOT_Parameters,       ONLY: NVAR, LU_NONZERO
+
+    IMPLICIT NONE
+
+    KPP_REAL, INTENT(IN) :: Tstart, Tend
+
+    KPP_REAL :: dt ! time step                                          
+    KPP_REAL :: k1(NVAR), k2(NVAR), w1(NVAR), g, jvs(LU_NONZERO)
+    INTEGER ising, i
+
+    dt = Tend - Tstart
+    g = 1.0 + SQRT(0.5_dp)
+    CALL JAC_sp(VAR, FIX, RCONST, jvs)
+    jvs(1:LU_NONZERO) = -g*dt*jvs(1:LU_NONZERO)
+
+    ! Rolf von Kuhlmann:
+    ! optionally cut this out and replace it by directly addressed statements
+    DO i=1,NVAR
+      jvs(LU_DIAG(i)) = jvs(LU_DIAG(i)) + 1.0_dp
+    END DO
+
+    CALL KppDecomp (jvs, ising)
+
+    IF (ising /= 0) THEN
+      PRINT *,'ising <> 0, dt=',dt
+      STOP
+    END IF
+
+    CALL Fun(VAR, FIX, RCONST, k1 )
+
+    CALL KppSolve (jvs,k1)
+
+    DO i = 1,NVAR
+      w1(i) = MAX(0.0_dp, VAR(i) + dt * k1(i) )
+    END DO
+
+    CALL Fun(w1, FIX, RCONST, k2 )
+
+    k2(1:NVAR) = k2(1:NVAR) - 2.0_dp*k1(1:NVAR)
+    CALL KppSolve (jvs,k2)
+    DO i = 1,NVAR
+      VAR(i) = MAX( 0.0_dp, VAR(i)+1.5_dp*dt*k1(i)+0.5_dp*dt*k2(i) )
+    END DO
+
+  END SUBROUTINE ROS2
+
+  ! **************************************************************************
+
+END MODULE KPP_ROOT_Integrator
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/int/DVODE/example1.f90
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/int/DVODE/example1.f90	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/int/DVODE/example1.f90	(revision 2696)
@@ -0,0 +1,116 @@
+    MODULE EXAMPLE1
+
+! DEMONSTRATION PROGRAM FOR THE DVODE_F90 PACKAGE.
+
+! The following is a simple example problem, with the coding
+! needed for its solution by DVODE_F90. The problem is from
+! chemical kinetics, and consists of the following three rate
+! equations:
+!     dy1/dt = -.04d0*y1 + 1.d4*y2*y3
+!     dy2/dt = .04d0*y1 - 1.d4*y2*y3 - 3.d7*y2**2
+!     dy3/dt = 3.d7*y2**2
+! on the interval from t = 0.0d0 to t = 4.d10, with initial
+! conditions y1 = 1.0d0, y2 = y3 = 0.0d0. The problem is stiff.
+
+! The following coding solves this problem with DVODE_F90,
+! using a user supplied Jacobian and printing results at
+! t = .4, 4.,...,4.d10. It uses ITOL = 2 and ATOL much smaller
+! for y2 than y1 or y3 because y2 has much smaller values. At
+! the end of the run, statistical quantities of interest are
+! printed. (See optional output in the full DVODE description
+! below.) Output is written to the file example1.dat.
+
+    CONTAINS
+
+      SUBROUTINE FEX(NEQ,T,Y,YDOT)
+        IMPLICIT NONE
+        INTEGER NEQ
+        DOUBLE PRECISION T, Y, YDOT
+        DIMENSION Y(NEQ), YDOT(NEQ)
+
+        YDOT(1) = -.04D0*Y(1) + 1.D4*Y(2)*Y(3)
+        YDOT(3) = 3.E7*Y(2)*Y(2)
+        YDOT(2) = -YDOT(1) - YDOT(3)
+        RETURN
+      END SUBROUTINE FEX
+
+      SUBROUTINE JEX(NEQ,T,Y,ML,MU,PD,NRPD)
+        IMPLICIT NONE
+        INTEGER NEQ, ML, MU, NRPD
+        DOUBLE PRECISION PD, T, Y
+        DIMENSION Y(NEQ), PD(NRPD,NEQ)
+
+        PD(1,1) = -.04D0
+        PD(1,2) = 1.D4*Y(3)
+        PD(1,3) = 1.D4*Y(2)
+        PD(2,1) = .04D0
+        PD(2,3) = -PD(1,3)
+        PD(3,2) = 6.E7*Y(2)
+        PD(2,2) = -PD(1,2) - PD(3,2)
+        RETURN
+      END SUBROUTINE JEX
+
+    END MODULE EXAMPLE1
+
+!******************************************************************
+
+    PROGRAM RUNEXAMPLE1
+
+      USE DVODE_F90_M
+      USE EXAMPLE1
+
+      IMPLICIT NONE
+      DOUBLE PRECISION ATOL, RTOL, T, TOUT, Y, RSTATS
+      INTEGER NEQ, ITASK, ISTATE, ISTATS, IOUT, IERROR, I
+      DIMENSION Y(3), ATOL(3), RSTATS(22), ISTATS(31)
+
+      TYPE (VODE_OPTS) :: OPTIONS
+
+      OPEN (UNIT=6,FILE='example1.dat')
+      IERROR = 0
+      NEQ = 3
+      Y(1) = 1.0D0
+      Y(2) = 0.0D0
+      Y(3) = 0.0D0
+      T = 0.0D0
+      TOUT = 0.4D0
+      RTOL = 1.D-4
+      ATOL(1) = 1.D-8
+      ATOL(2) = 1.D-14
+      ATOL(3) = 1.D-6
+      ITASK = 1
+      ISTATE = 1
+!     OPTIONS = SET_OPTS(DENSE_J=.TRUE.,ABSERR_VECTOR=ATOL,RELERR=RTOL, &
+!       USER_SUPPLIED_JACOBIAN=.TRUE.)
+      OPTIONS = SET_NORMAL_OPTS(DENSE_J=.TRUE.,ABSERR_VECTOR=ATOL,      &
+        RELERR=RTOL,USER_SUPPLIED_JACOBIAN=.TRUE.)
+      DO IOUT = 1, 12
+        CALL DVODE_F90(FEX,NEQ,Y,T,TOUT,ITASK,ISTATE,OPTIONS,J_FCN=JEX)
+        CALL GET_STATS(RSTATS,ISTATS)
+        WRITE (6,90003) T, Y(1), Y(2), Y(3)
+        DO I = 1, NEQ
+          IF (Y(I)<0.0D0) IERROR = 1
+        END DO
+        IF (ISTATE<0) THEN
+          WRITE (6,90004) ISTATE
+          STOP
+        END IF
+        TOUT = TOUT*10.0D0
+      END DO
+      WRITE (6,90000) ISTATS(11), ISTATS(12), ISTATS(13), ISTATS(19), &
+        ISTATS(20), ISTATS(21), ISTATS(22)
+      IF (IERROR==1) THEN
+        WRITE (6,90001)
+      ELSE
+        WRITE (6,90002)
+      END IF
+90000 FORMAT (/'  No. steps =',I4,'   No. f-s =',I4,'  No. J-s =',I4, &
+        '   No. LU-s =',I4/'  No. nonlinear iterations =', &
+        I4/'  No. nonlinear convergence failures =', &
+        I4/'  No. error test failures =',I4/)
+90001 FORMAT (/' An error occurred.')
+90002 FORMAT (/' No errors occurred.')
+90003 FORMAT (' At t =',D12.4,'   y =',3D14.6)
+90004 FORMAT (///' Error halt: ISTATE =',I3)
+      STOP
+    END PROGRAM RUNEXAMPLE1
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/int/DVODE/example1.mod
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/int/DVODE/example1.mod	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/int/DVODE/example1.mod	(revision 2696)
@@ -0,0 +1,46 @@
+V24 example1
+12 example1.f90 S582 0
+05/10/2011  17:19:07
+enduse
+D 33 21 9 1 3 13 0 0 1 0 0
+ 0 12 3 3 13 13
+D 36 21 9 1 3 13 0 0 1 0 0
+ 0 12 3 3 13 13
+D 39 21 9 1 3 15 0 0 1 0 0
+ 0 14 3 3 15 15
+D 42 21 9 2 16 19 0 0 1 0 0
+ 0 17 3 3 18 18
+ 0 14 18 3 15 15
+S 582 24 0 0 0 8 1 0 4668 5 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 0 0 0 0 0 example1
+S 583 23 5 0 0 0 588 582 4677 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 fex
+S 584 6 3 0 0 6 1 583 4681 800004 3000 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 neq
+S 585 1 3 0 0 9 1 583 4685 4 3000 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 t
+S 586 7 3 0 0 33 1 583 4687 800204 3000 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 y
+S 587 7 3 0 0 36 1 583 4689 800204 3000 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 ydot
+S 588 14 5 0 0 0 1 583 4677 200 400000 0 0 0 2 4 0 0 0 0 0 0 0 0 0 0 0 0 25 0 582 0 0 0 0 fex
+F 588 4 584 585 586 587
+S 589 6 1 0 0 6 1 583 4694 40800006 3000 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 z_e_12
+S 590 23 5 0 0 0 598 582 4701 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 jex
+S 591 6 3 0 0 6 1 590 4681 800004 3000 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 neq
+S 592 1 3 0 0 9 1 590 4685 4 3000 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 t
+S 593 7 3 0 0 39 1 590 4687 800204 3000 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 y
+S 594 1 3 0 0 6 1 590 4705 4 3000 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 ml
+S 595 1 3 0 0 6 1 590 4708 4 3000 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 mu
+S 596 7 3 0 0 42 1 590 4711 800204 3000 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 pd
+S 597 6 3 0 0 6 1 590 4714 800004 3000 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 nrpd
+S 598 14 5 0 0 0 1 590 4701 200 400000 0 0 0 7 7 0 0 0 0 0 0 0 0 0 0 0 0 37 0 582 0 0 0 0 jex
+F 598 7 591 592 593 594 595 596 597
+S 599 6 1 0 0 6 1 590 4719 40800006 3000 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 z_e_14
+S 600 6 1 0 0 6 1 590 4726 40800006 3000 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 z_e_16
+S 601 6 1 0 0 6 1 590 4733 40800006 3000 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 z_e_18
+S 602 6 1 0 0 6 1 590 4740 40800006 3000 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 z_e_20
+A 12 1 0 0 0 6 584 0 0 0 0 0 0 0 0 0 0 0 0 0
+A 13 1 0 0 0 6 589 0 0 0 0 0 0 0 0 0 0 0 0 0
+A 14 1 0 0 0 6 591 0 0 0 0 0 0 0 0 0 0 0 0 0
+A 15 1 0 0 0 6 599 0 0 0 0 0 0 0 0 0 0 0 0 0
+A 16 1 0 0 0 6 602 0 0 0 0 0 0 0 0 0 0 0 0 0
+A 17 1 0 0 0 6 597 0 0 0 0 0 0 0 0 0 0 0 0 0
+A 18 1 0 0 0 6 600 0 0 0 0 0 0 0 0 0 0 0 0 0
+A 19 1 0 0 0 6 601 0 0 0 0 0 0 0 0 0 0 0 0 0
+Z
+Z
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/int/DVODE/example2.f90
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/int/DVODE/example2.f90	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/int/DVODE/example2.f90	(revision 2696)
@@ -0,0 +1,118 @@
+    MODULE EXAMPLE2
+
+! DEMONSTRATION PROGRAM FOR THE DVODE_F90 PACKAGE.
+
+! The following is a modification of the previous example
+! program to illustrate root finding. The problem is from
+! chemical kinetics, and consists of the following three
+! rate equations:
+!     dy1/dt = -.04d0*y1 + 1.d4*y2*y3
+!     dy2/dt = .04d0*y1 - 1.d4*y2*y3 - 3.d7*y2**2
+!     dy3/dt = 3.d7*y2**2
+! on the interval from t = 0.0d0 to t = 4.d10, with initial
+! conditions y1 = 1.0d0, y2 = y3 = 0.0d0. The problem is stiff.
+! In addition, we want to find the values of t, y1, y2,
+! and y3 at which:
+!   (1) y1 reaches the value 1.d-4, and
+!   (2) y3 reaches the value 1.d-2.
+
+! The following coding solves this problem with DVODE_F90
+! using an internally generated dense Jacobian and
+! printing results at t = .4, 4., ..., 4.d10, and at the
+! computed roots. It uses ITOL = 2 and ATOL much smaller
+! for y2 than y1 or y3 because y2 has much smaller values.
+! At the end of the run, statistical quantities of interest
+! are printed (see optional outputs in the full description
+! below). Output is written to the file example2.dat.
+
+    CONTAINS
+
+      SUBROUTINE FEX(NEQ,T,Y,YDOT)
+        IMPLICIT NONE
+        INTEGER NEQ
+        DOUBLE PRECISION T, Y, YDOT
+        DIMENSION Y(3), YDOT(3)
+
+        YDOT(1) = -0.04D0*Y(1) + 1.0D4*Y(2)*Y(3)
+        YDOT(3) = 3.0D7*Y(2)*Y(2)
+        YDOT(2) = -YDOT(1) - YDOT(3)
+        RETURN
+      END SUBROUTINE FEX
+
+      SUBROUTINE GEX(NEQ,T,Y,NG,GOUT)
+        IMPLICIT NONE
+        INTEGER NEQ, NG
+        DOUBLE PRECISION T, Y, GOUT
+        DIMENSION Y(3), GOUT(2)
+
+        GOUT(1) = Y(1) - 1.0D-4
+        GOUT(2) = Y(3) - 1.0D-2
+        RETURN
+      END SUBROUTINE GEX
+
+    END MODULE EXAMPLE2
+
+!******************************************************************
+
+    PROGRAM RUNEXAMPLE2
+
+      USE DVODE_F90_M
+      USE EXAMPLE2
+
+      IMPLICIT NONE
+      INTEGER ITASK, ISTATE, NG, NEQ, IOUT, JROOT, ISTATS, IERROR, I
+      DOUBLE PRECISION ATOL, RTOL, RSTATS, T, TOUT, Y
+      DIMENSION Y(3), ATOL(3), RSTATS(22), ISTATS(31), JROOT(2)
+
+      TYPE (VODE_OPTS) :: OPTIONS
+
+      OPEN (UNIT=6,FILE='example2.dat')
+      IERROR = 0
+      NEQ = 3
+      Y(1) = 1.0D0
+      Y(2) = 0.0D0
+      Y(3) = 0.0D0
+      T = 0.0D0
+      TOUT = 0.4D0
+      RTOL = 1.0D-4
+      ATOL(1) = 1.0D-8
+      ATOL(2) = 1.0D-10
+      ATOL(3) = 1.0D-8
+      ITASK = 1
+      ISTATE = 1
+      NG = 2
+!     OPTIONS = SET_OPTS(DENSE_J=.TRUE.,RELERR=RTOL,ABSERR_VECTOR=ATOL, &
+!       NEVENTS=NG)
+      OPTIONS = SET_NORMAL_OPTS(DENSE_J=.TRUE.,RELERR=RTOL,             &
+        ABSERR_VECTOR=ATOL,NEVENTS=NG)
+      DO 20 IOUT = 1, 12
+10      CONTINUE
+        CALL DVODE_F90(FEX,NEQ,Y,T,TOUT,ITASK,ISTATE,OPTIONS,G_FCN=GEX)
+        CALL GET_STATS(RSTATS,ISTATS,NG,JROOT)
+        WRITE (6,90000) T, Y(1), Y(2), Y(3)
+        DO I = 1, NEQ
+          IF (Y(I)<0.0D0) IERROR = 1
+        END DO
+90000   FORMAT (' At t =',D12.4,'   Y =',3D14.6)
+        IF (ISTATE<0) GO TO 30
+        IF (ISTATE==2) GO TO 20
+        WRITE (6,90001) JROOT(1), JROOT(2)
+90001   FORMAT (5X,' The above line is a root, JROOT =',2I5)
+        ISTATE = 2
+        GO TO 10
+20    TOUT = TOUT*10.0D0
+      WRITE (6,90002) ISTATS(11), ISTATS(12), ISTATS(13), ISTATS(10)
+      IF (IERROR==1) THEN
+        WRITE (6,90003)
+      ELSE
+        WRITE (6,90004)
+      END IF
+90002 FORMAT (/' No. steps =',I4,'  No. f-s =',I4,'  No. J-s =',I4, &
+        '  No. g-s =',I4/)
+      STOP
+30    WRITE (6,90005) ISTATE
+90003 FORMAT (/' An error occurred.')
+90004 FORMAT (/' No errors occurred.')
+90005 FORMAT (///' Error halt.. ISTATE =',I3)
+      STOP
+    END PROGRAM RUNEXAMPLE2
